# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class FileOutput(pydantic.BaseModel):
    """
    A file object that can be used to read a file resource.
    """

    content_type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The content type of the file.
    """

    filename: typing.Optional[str] = pydantic.Field(default=None)
    """
    The name of the file.
    """

    filesize: typing.Optional[int] = pydantic.Field(default=None)
    """
    The size of the file in bytes.
    """

    multihash: typing.Optional[str] = pydantic.Field(default=None)
    """
    The multihash of the file. [Multihash](https://www.w3.org/TR/vc-data-integrity/#multihash).
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
